Index: uspace/srv/hid/output/port/ddev.c
===================================================================
--- uspace/srv/hid/output/port/ddev.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/srv/hid/output/port/ddev.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,325 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2008 Martin Decky
+ * Copyright (c) 2006 Jakub Vana
+ * Copyright (c) 2006 Ondrej Palkovsky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup output
+ * @{
+ */
+
+#include <ddev.h>
+#include <errno.h>
+#include <fbfont/font-8x16.h>
+#include <gfx/bitmap.h>
+#include <gfx/color.h>
+#include <gfx/coord.h>
+#include <gfx/context.h>
+#include <gfx/render.h>
+#include <io/chargrid.h>
+#include <io/pixelmap.h>
+#include <stdlib.h>
+#include "../output.h"
+#include "ddev.h"
+
+#define KFB_DDEV_NAME "devices/\\virt\\kfb\\kfb"
+
+typedef struct {
+	gfx_context_t *gc;
+
+	sysarg_t cols;
+	sysarg_t rows;
+
+	uint8_t style_normal;
+	uint8_t style_inverted;
+
+	gfx_bitmap_t *bitmap;
+	pixelmap_t pixelmap;
+	gfx_rect_t dirty;
+
+	sysarg_t curs_col;
+	sysarg_t curs_row;
+	bool curs_visible;
+} output_ddev_t;
+
+static pixel_t color_table[16] = {
+	[COLOR_BLACK]       = 0x000000,
+	[COLOR_BLUE]        = 0x0000f0,
+	[COLOR_GREEN]       = 0x00f000,
+	[COLOR_CYAN]        = 0x00f0f0,
+	[COLOR_RED]         = 0xf00000,
+	[COLOR_MAGENTA]     = 0xf000f0,
+	[COLOR_YELLOW]      = 0xf0f000,
+	[COLOR_WHITE]       = 0xf0f0f0,
+
+	[COLOR_BLACK + 8]   = 0x000000,
+	[COLOR_BLUE + 8]    = 0x0000ff,
+	[COLOR_GREEN + 8]   = 0x00ff00,
+	[COLOR_CYAN + 8]    = 0x00ffff,
+	[COLOR_RED + 8]     = 0xff0000,
+	[COLOR_MAGENTA + 8] = 0xff00ff,
+	[COLOR_YELLOW + 8]  = 0xffff00,
+	[COLOR_WHITE + 8]   = 0xffffff,
+};
+
+static void attrs_rgb(char_attrs_t attrs, pixel_t *bgcolor, pixel_t *fgcolor)
+{
+	switch (attrs.type) {
+	case CHAR_ATTR_STYLE:
+		switch (attrs.val.style) {
+		case STYLE_NORMAL:
+			*bgcolor = color_table[COLOR_WHITE];
+			*fgcolor = color_table[COLOR_BLACK];
+			break;
+		case STYLE_EMPHASIS:
+			*bgcolor = color_table[COLOR_WHITE];
+			*fgcolor = color_table[COLOR_RED];
+			break;
+		case STYLE_INVERTED:
+			*bgcolor = color_table[COLOR_BLACK];
+			*fgcolor = color_table[COLOR_WHITE];
+			break;
+		case STYLE_SELECTED:
+			*bgcolor = color_table[COLOR_RED];
+			*fgcolor = color_table[COLOR_WHITE];
+			break;
+		}
+		break;
+	case CHAR_ATTR_INDEX:
+		*bgcolor = color_table[(attrs.val.index.bgcolor & 7) |
+		    ((attrs.val.index.attr & CATTR_BRIGHT) ? 8 : 0)];
+		*fgcolor = color_table[(attrs.val.index.fgcolor & 7) |
+		    ((attrs.val.index.attr & CATTR_BRIGHT) ? 8 : 0)];
+		break;
+	case CHAR_ATTR_RGB:
+		*bgcolor = attrs.val.rgb.bgcolor;
+		*fgcolor = attrs.val.rgb.fgcolor;
+		break;
+	}
+}
+
+/** Draw the character at the specified position.
+ *
+ * @param field Character field.
+ * @param col   Horizontal screen position.
+ * @param row   Vertical screen position.
+ *
+ */
+static void draw_char(output_ddev_t *ddev, charfield_t *field,
+    sysarg_t col, sysarg_t row)
+{
+	pixel_t fgcolor;
+	pixel_t bgcolor;
+	pixel_t pcolor;
+	pixel_t tmp;
+	gfx_rect_t rect;
+	gfx_rect_t ndrect;
+	gfx_coord_t x, y;
+	bool inverted;
+	uint32_t glyph;
+
+	fgcolor = bgcolor = 0;
+	attrs_rgb(field->attrs, &bgcolor, &fgcolor);
+
+	inverted = (col == ddev->curs_col) && (row == ddev->curs_row) &&
+	    ddev->curs_visible;
+
+	if (inverted) {
+		/* Swap foreground and background colors */
+		tmp = bgcolor;
+		bgcolor = fgcolor;
+		fgcolor = tmp;
+	}
+
+	rect.p0.x = FONT_WIDTH * col;
+	rect.p0.y = FONT_SCANLINES * row;
+	rect.p1.x = FONT_WIDTH * (col + 1);
+	rect.p1.y = FONT_SCANLINES * (row + 1);
+
+	glyph = fb_font_glyph(field->ch, NULL);
+
+	for (y = 0; y < FONT_SCANLINES; y++) {
+		for (x = 0; x < FONT_WIDTH; x++) {
+			pcolor = fb_font[glyph][y] & (1 << (7 - x)) ?
+			    fgcolor : bgcolor;
+			pixelmap_put_pixel(&ddev->pixelmap,
+			    rect.p0.x + x, rect.p0.y + y, pcolor);
+		}
+	}
+
+	/* Compute new dirty rectangle */
+	gfx_rect_envelope(&ddev->dirty, &rect, &ndrect);
+	ddev->dirty = ndrect;
+}
+
+static errno_t output_ddev_yield(outdev_t *dev)
+{
+	return EOK;
+}
+
+static errno_t output_ddev_claim(outdev_t *dev)
+{
+	return EOK;
+}
+
+static void output_ddev_get_dimensions(outdev_t *dev, sysarg_t *cols, sysarg_t *rows)
+{
+	output_ddev_t *ddev = (output_ddev_t *) dev->data;
+
+	*cols = ddev->cols;
+	*rows = ddev->rows;
+}
+
+static console_caps_t output_ddev_get_caps(outdev_t *dev)
+{
+	return (CONSOLE_CAP_STYLE | CONSOLE_CAP_INDEXED | CONSOLE_CAP_RGB);
+}
+
+static void output_ddev_char_update(outdev_t *dev, sysarg_t col, sysarg_t row)
+{
+	output_ddev_t *ddev = (output_ddev_t *) dev->data;
+
+	charfield_t *field =
+	    chargrid_charfield_at(dev->backbuf, col, row);
+
+	draw_char(ddev, field, col, row);
+}
+
+static void output_ddev_cursor_update(outdev_t *dev, sysarg_t prev_col,
+    sysarg_t prev_row, sysarg_t col, sysarg_t row, bool visible)
+{
+	output_ddev_t *ddev = (output_ddev_t *) dev->data;
+
+	ddev->curs_col = col;
+	ddev->curs_row = row;
+	ddev->curs_visible = visible;
+
+	output_ddev_char_update(dev, prev_col, prev_row);
+	output_ddev_char_update(dev, col, row);
+}
+
+static void output_ddev_flush(outdev_t *dev)
+{
+	output_ddev_t *ddev = (output_ddev_t *) dev->data;
+
+	(void) gfx_bitmap_render(ddev->bitmap, &ddev->dirty, NULL);
+
+	ddev->dirty.p0.x = 0;
+	ddev->dirty.p0.y = 0;
+	ddev->dirty.p1.x = 0;
+	ddev->dirty.p1.y = 0;
+}
+
+static outdev_ops_t output_ddev_ops = {
+	.yield = output_ddev_yield,
+	.claim = output_ddev_claim,
+	.get_dimensions = output_ddev_get_dimensions,
+	.get_caps = output_ddev_get_caps,
+	.cursor_update = output_ddev_cursor_update,
+	.char_update = output_ddev_char_update,
+	.flush = output_ddev_flush
+};
+
+errno_t output_ddev_init(void)
+{
+	ddev_t *dd = NULL;
+	output_ddev_t *ddev = NULL;
+	ddev_info_t info;
+	gfx_coord2_t dims;
+	gfx_context_t *gc;
+	gfx_bitmap_params_t params;
+	gfx_bitmap_alloc_t alloc;
+	gfx_bitmap_t *bitmap = NULL;
+	errno_t rc;
+
+	ddev = calloc(1, sizeof(output_ddev_t));
+	if (ddev == NULL)
+		return ENOMEM;
+
+	rc = ddev_open(KFB_DDEV_NAME, &dd);
+	if (rc != EOK) {
+		printf("Error opening display device '%s'.", KFB_DDEV_NAME);
+		goto error;
+	}
+
+	rc = ddev_get_info(dd, &info);
+	if (rc != EOK) {
+		printf("Error getting information for display device '%s'.",
+		    KFB_DDEV_NAME);
+		goto error;
+	}
+
+	rc = ddev_get_gc(dd, &gc);
+	if (rc != EOK) {
+		printf("Error getting device context for '%s'.", KFB_DDEV_NAME);
+		goto error;
+	}
+
+	gfx_bitmap_params_init(&params);
+	params.rect = info.rect;
+
+	rc = gfx_bitmap_create(gc, &params, NULL, &bitmap);
+	if (rc != EOK) {
+		printf("Error creating screen bitmap.\n");
+		goto error;
+	}
+
+	rc = gfx_bitmap_get_alloc(bitmap, &alloc);
+	if (rc != EOK) {
+		printf("Error getting bitmap allocation info.\n");
+		goto error;
+	}
+
+	gfx_rect_dims(&info.rect, &dims);
+
+	ddev->gc = gc;
+	ddev->cols = dims.x / FONT_WIDTH;
+	ddev->rows = dims.y / FONT_SCANLINES;
+	ddev->bitmap = bitmap;
+	ddev->pixelmap.width = dims.x;
+	ddev->pixelmap.height = dims.y;
+	ddev->pixelmap.data = alloc.pixels;
+
+	outdev_t *dev = outdev_register(&output_ddev_ops, (void *) ddev);
+	if (dev == NULL) {
+		rc = EINVAL;
+		goto error;
+	}
+
+	return EOK;
+error:
+	if (dd != NULL)
+		ddev_close(dd);
+	if (bitmap != NULL)
+		gfx_bitmap_destroy(bitmap);
+	free(ddev);
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/srv/hid/output/port/ddev.h
===================================================================
--- uspace/srv/hid/output/port/ddev.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/srv/hid/output/port/ddev.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,41 @@
+/*
+ * Copyright (c) 2020 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup output
+ * @{
+ */
+
+#ifndef OUTPUT_PORT_DDEV_H_
+#define OUTPUT_PORT_DDEV_H_
+
+extern errno_t output_ddev_init(void);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/output/proto/vt100.c
===================================================================
--- uspace/srv/hid/output/proto/vt100.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/output/proto/vt100.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -65,5 +66,5 @@
 static sgr_color_index_t color_map[] = {
 	[COLOR_BLACK]   = CI_BLACK,
-	[COLOR_BLUE]    = CI_RED,
+	[COLOR_BLUE]    = CI_BLUE,
 	[COLOR_GREEN]   = CI_GREEN,
 	[COLOR_CYAN]    = CI_CYAN,
Index: uspace/srv/hid/remcons/meson.build
===================================================================
--- uspace/srv/hid/remcons/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/remcons/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2012 Vojtech Horky
 # All rights reserved.
@@ -27,3 +28,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('remcons.c', 'user.c')
Index: uspace/srv/hid/rfb/main.c
===================================================================
--- uspace/srv/hid/rfb/main.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/rfb/main.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Martin Sucha
  * All rights reserved.
@@ -50,4 +51,5 @@
 static errno_t rfb_ddev_get_info(void *, ddev_info_t *);
 
+static errno_t rfb_gc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t rfb_gc_set_color(void *, gfx_color_t *);
 static errno_t rfb_gc_fill_rect(void *, gfx_rect_t *);
@@ -66,4 +68,6 @@
 	rfb_t rfb;
 	pixel_t color;
+	gfx_rect_t rect;
+	gfx_rect_t clip_rect;
 } rfb_gc_t;
 
@@ -78,4 +82,5 @@
 
 static gfx_context_ops_t rfb_gc_ops = {
+	.set_clip_rect = rfb_gc_set_clip_rect,
 	.set_color = rfb_gc_set_color,
 	.fill_rect = rfb_gc_fill_rect,
@@ -134,4 +139,49 @@
 }
 
+/** Create RFB GC.
+ *
+ * @param rrgb Place to store pointer to new RFB GC
+ * @return EOK on success, ENOMEM if out of memory
+ */
+static errno_t rgb_gc_create(rfb_gc_t **rrfb)
+{
+	rfb_gc_t *rfb;
+
+	rfb = calloc(1, sizeof(rfb_gc_t));
+	if (rfb == NULL)
+		return ENOMEM;
+
+	*rrfb = rfb;
+	return EOK;
+}
+
+/** Destroy RFB GC.
+ *
+ * @param rfb RFB GC
+ */
+static void rfb_gc_destroy(rfb_gc_t *rfb)
+{
+	free(rfb);
+}
+
+/** Set clipping rectangle on RFB.
+ *
+ * @param arg RFB
+ * @param rect Rectangle or @c NULL
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t rfb_gc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	rfb_gc_t *rfb = (rfb_gc_t *) arg;
+
+	if (rect != NULL)
+		gfx_rect_clip(rect, &rfb->rect, &rfb->clip_rect);
+	else
+		rfb->clip_rect = rfb->rect;
+
+	return EOK;
+}
+
 /** Set color on RFB.
  *
@@ -163,10 +213,11 @@
 {
 	rfb_gc_t *rfb = (rfb_gc_t *) arg;
+	gfx_rect_t crect;
 	gfx_coord_t x, y;
 
-	// XXX We should handle p0.x > p1.x and p0.y > p1.y
-
-	for (y = rect->p0.y; y < rect->p1.y; y++) {
-		for (x = rect->p0.x; x < rect->p1.x; x++) {
+	gfx_rect_clip(rect, &rfb->clip_rect, &crect);
+
+	for (y = crect.p0.y; y < crect.p1.y; y++) {
+		for (x = crect.p0.x; x < crect.p1.x; x++) {
 			pixelmap_put_pixel(&rfb->rfb.framebuffer, x, y,
 			    rfb->color);
@@ -174,5 +225,5 @@
 	}
 
-	rfb_gc_invalidate_rect(rfb, rect);
+	rfb_gc_invalidate_rect(rfb, &crect);
 
 	return EOK;
@@ -258,4 +309,5 @@
 	gfx_rect_t srect;
 	gfx_rect_t drect;
+	gfx_rect_t crect;
 	gfx_coord2_t offs;
 	gfx_coord2_t bmdim;
@@ -279,5 +331,6 @@
 	/* Destination rectangle */
 	gfx_rect_translate(&offs, &srect, &drect);
-	gfx_coord2_subtract(&drect.p1, &drect.p0, &dim);
+	gfx_rect_clip(&drect, &rfbbm->rfb->clip_rect, &crect);
+	gfx_coord2_subtract(&crect.p1, &crect.p0, &dim);
 	gfx_coord2_subtract(&rfbbm->rect.p1, &rfbbm->rect.p0, &bmdim);
 
@@ -320,5 +373,5 @@
 	}
 
-	rfb_gc_invalidate_rect(rfbbm->rfb, &drect);
+	rfb_gc_invalidate_rect(rfbbm->rfb, &crect);
 
 	return EOK;
@@ -346,4 +399,5 @@
 {
 	rfb_t *rfb = (rfb_t *) arg;
+	rfb_gc_t *rfbgc;
 	ddev_srv_t srv;
 	sysarg_t svc_id;
@@ -362,6 +416,19 @@
 		ddev_conn(icall, &srv);
 	} else {
-		rc = gfx_context_new(&rfb_gc_ops, (void *) rfb, &gc);
+		rc = rgb_gc_create(&rfbgc);
 		if (rc != EOK) {
+			async_answer_0(icall, ENOMEM);
+			return;
+		}
+
+		rfbgc->rect.p0.x = 0;
+		rfbgc->rect.p0.y = 0;
+		rfbgc->rect.p1.x = rfb->width;
+		rfbgc->rect.p1.y = rfb->height;
+		rfbgc->clip_rect = rfbgc->rect;
+
+		rc = gfx_context_new(&rfb_gc_ops, (void *) rfbgc, &gc);
+		if (rc != EOK) {
+			rfb_gc_destroy(rfbgc);
 			async_answer_0(icall, ENOMEM);
 			return;
Index: uspace/srv/hid/rfb/meson.build
===================================================================
--- uspace/srv/hid/rfb/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hid/rfb/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2013 Martin Sucha
 # All rights reserved.
@@ -27,4 +28,4 @@
 #
 
-deps = [ 'ipcgfx', 'ddev' ]
+deps = [ 'inet', 'ipcgfx', 'ddev' ]
 src = files('main.c', 'rfb.c')
Index: uspace/srv/hw/char/s3c24xx_uart/meson.build
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/hw/char/s3c24xx_uart/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -28,3 +28,4 @@
 #
 
+deps = [ 'device' ]
 src = files('s3c24xx_uart.c')
Index: uspace/srv/net/dhcp/dhcp.c
===================================================================
--- uspace/srv/net/dhcp/dhcp.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/dhcp/dhcp.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,4 +42,5 @@
 #include <fibril_synch.h>
 #include <inet/addr.h>
+#include <inet/eth_addr.h>
 #include <inet/dnsr.h>
 #include <inet/inetcfg.h>
@@ -157,9 +158,9 @@
 	hdr->op = op_bootrequest;
 	hdr->htype = 1; /* AHRD_ETHERNET */
-	hdr->hlen = sizeof(addr48_t);
+	hdr->hlen = ETH_ADDR_SIZE;
 	hdr->xid = host2uint32_t_be(42);
 	hdr->flags = flag_broadcast;
 
-	addr48(dlink->link_info.mac_addr, hdr->chaddr);
+	eth_addr_encode(&dlink->link_info.mac_addr, hdr->chaddr);
 	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
 
@@ -185,5 +186,5 @@
 	hdr->flags = flag_broadcast;
 	hdr->ciaddr = host2uint32_t_be(offer->oaddr.addr);
-	addr48(dlink->link_info.mac_addr, hdr->chaddr);
+	eth_addr_encode(&dlink->link_info.mac_addr, hdr->chaddr);
 	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
 
Index: uspace/srv/net/dhcp/meson.build
===================================================================
--- uspace/srv/net/dhcp/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/dhcp/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2013 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,4 +27,5 @@
 #
 
+deps = [ 'inet' ]
 src = files(
 	'dhcp.c',
Index: uspace/srv/net/dnsrsrv/meson.build
===================================================================
--- uspace/srv/net/dnsrsrv/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/dnsrsrv/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2012 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,4 +27,5 @@
 #
 
+deps = [ 'inet' ]
 src = files(
 	'dns_msg.c',
Index: uspace/srv/net/ethip/arp.c
===================================================================
--- uspace/srv/net/ethip/arp.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/arp.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,7 +36,8 @@
 
 #include <errno.h>
-#include <io/log.h>
 #include <inet/iplink_srv.h>
 #include <inet/addr.h>
+#include <inet/eth_addr.h>
+#include <io/log.h>
 #include <stdlib.h>
 #include "arp.h"
@@ -79,5 +80,5 @@
 
 	(void) atrans_add(packet.sender_proto_addr,
-	    packet.sender_hw_addr);
+	    &packet.sender_hw_addr);
 
 	if (packet.opcode == aop_request) {
@@ -85,7 +86,7 @@
 
 		reply.opcode = aop_reply;
-		addr48(nic->mac_addr, reply.sender_hw_addr);
+		reply.sender_hw_addr = nic->mac_addr;
 		reply.sender_proto_addr = laddr_v4;
-		addr48(packet.sender_hw_addr, reply.target_hw_addr);
+		reply.target_hw_addr = packet.sender_hw_addr;
 		reply.target_proto_addr = packet.sender_proto_addr;
 
@@ -95,9 +96,9 @@
 
 errno_t arp_translate(ethip_nic_t *nic, addr32_t src_addr, addr32_t ip_addr,
-    addr48_t mac_addr)
+    eth_addr_t *mac_addr)
 {
 	/* Broadcast address */
 	if (ip_addr == addr32_broadcast_all_hosts) {
-		addr48(addr48_broadcast, mac_addr);
+		*mac_addr = eth_addr_broadcast;
 		return EOK;
 	}
@@ -110,7 +111,7 @@
 
 	packet.opcode = aop_request;
-	addr48(nic->mac_addr, packet.sender_hw_addr);
+	packet.sender_hw_addr = nic->mac_addr;
 	packet.sender_proto_addr = src_addr;
-	addr48(addr48_broadcast, packet.target_hw_addr);
+	packet.target_hw_addr = eth_addr_broadcast;
 	packet.target_proto_addr = ip_addr;
 
@@ -138,6 +139,6 @@
 		return rc;
 
-	addr48(packet->target_hw_addr, frame.dest);
-	addr48(packet->sender_hw_addr, frame.src);
+	frame.dest = packet->target_hw_addr;
+	frame.src = packet->sender_hw_addr;
 	frame.etype_len = ETYPE_ARP;
 	frame.data = pdata;
Index: uspace/srv/net/ethip/arp.h
===================================================================
--- uspace/srv/net/ethip/arp.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/arp.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,10 +38,11 @@
 #define ARP_H_
 
+#include <inet/addr.h>
+#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
-#include <inet/addr.h>
 #include "ethip.h"
 
 extern void arp_received(ethip_nic_t *, eth_frame_t *);
-extern errno_t arp_translate(ethip_nic_t *, addr32_t, addr32_t, addr48_t);
+extern errno_t arp_translate(ethip_nic_t *, addr32_t, addr32_t, eth_addr_t *);
 
 #endif
Index: uspace/srv/net/ethip/atrans.c
===================================================================
--- uspace/srv/net/ethip/atrans.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/atrans.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,4 +38,5 @@
 #include <errno.h>
 #include <fibril_synch.h>
+#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <stdlib.h>
@@ -59,5 +60,5 @@
 }
 
-errno_t atrans_add(addr32_t ip_addr, addr48_t mac_addr)
+errno_t atrans_add(addr32_t ip_addr, eth_addr_t *mac_addr)
 {
 	ethip_atrans_t *atrans;
@@ -69,5 +70,5 @@
 
 	atrans->ip_addr = ip_addr;
-	addr48(mac_addr, atrans->mac_addr);
+	atrans->mac_addr = *mac_addr;
 
 	fibril_mutex_lock(&atrans_list_lock);
@@ -103,5 +104,5 @@
 }
 
-static errno_t atrans_lookup_locked(addr32_t ip_addr, addr48_t mac_addr)
+static errno_t atrans_lookup_locked(addr32_t ip_addr, eth_addr_t *mac_addr)
 {
 	ethip_atrans_t *atrans = atrans_find(ip_addr);
@@ -109,9 +110,9 @@
 		return ENOENT;
 
-	addr48(atrans->mac_addr, mac_addr);
+	*mac_addr = atrans->mac_addr;
 	return EOK;
 }
 
-errno_t atrans_lookup(addr32_t ip_addr, addr48_t mac_addr)
+errno_t atrans_lookup(addr32_t ip_addr, eth_addr_t *mac_addr)
 {
 	errno_t rc;
@@ -135,5 +136,5 @@
 
 errno_t atrans_lookup_timeout(addr32_t ip_addr, usec_t timeout,
-    addr48_t mac_addr)
+    eth_addr_t *mac_addr)
 {
 	fibril_timer_t *t;
Index: uspace/srv/net/ethip/atrans.h
===================================================================
--- uspace/srv/net/ethip/atrans.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/atrans.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,12 +38,13 @@
 #define ATRANS_H_
 
+#include <inet/addr.h>
+#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
-#include <inet/addr.h>
 #include "ethip.h"
 
-extern errno_t atrans_add(addr32_t, addr48_t);
+extern errno_t atrans_add(addr32_t, eth_addr_t *);
 extern errno_t atrans_remove(addr32_t);
-extern errno_t atrans_lookup(addr32_t, addr48_t);
-extern errno_t atrans_lookup_timeout(addr32_t, usec_t, addr48_t);
+extern errno_t atrans_lookup(addr32_t, eth_addr_t *);
+extern errno_t atrans_lookup_timeout(addr32_t, usec_t, eth_addr_t *);
 
 #endif
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/ethip.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,4 +39,5 @@
 #include <async.h>
 #include <errno.h>
+#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <io/log.h>
@@ -58,6 +59,6 @@
 static errno_t ethip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu);
 static errno_t ethip_get_mtu(iplink_srv_t *srv, size_t *mtu);
-static errno_t ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac);
-static errno_t ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac);
+static errno_t ethip_get_mac48(iplink_srv_t *srv, eth_addr_t *mac);
+static errno_t ethip_set_mac48(iplink_srv_t *srv, eth_addr_t *mac);
 static errno_t ethip_addr_add(iplink_srv_t *srv, inet_addr_t *addr);
 static errno_t ethip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr);
@@ -177,5 +178,5 @@
 	eth_frame_t frame;
 
-	errno_t rc = arp_translate(nic, sdu->src, sdu->dest, frame.dest);
+	errno_t rc = arp_translate(nic, sdu->src, sdu->dest, &frame.dest);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "Failed to look up IPv4 address 0x%"
@@ -184,5 +185,5 @@
 	}
 
-	addr48(nic->mac_addr, frame.src);
+	frame.src = nic->mac_addr;
 	frame.etype_len = ETYPE_IP;
 	frame.data = sdu->data;
@@ -208,6 +209,6 @@
 	eth_frame_t frame;
 
-	addr48(sdu->dest, frame.dest);
-	addr48(nic->mac_addr, frame.src);
+	frame.dest = sdu->dest;
+	frame.src = nic->mac_addr;
 	frame.etype_len = ETYPE_IPV6;
 	frame.data = sdu->data;
@@ -276,20 +277,20 @@
 }
 
-static errno_t ethip_get_mac48(iplink_srv_t *srv, addr48_t *mac)
+static errno_t ethip_get_mac48(iplink_srv_t *srv, eth_addr_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_get_mac48()");
 
 	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
-	addr48(nic->mac_addr, *mac);
-
-	return EOK;
-}
-
-static errno_t ethip_set_mac48(iplink_srv_t *srv, addr48_t *mac)
+	*mac = nic->mac_addr;
+
+	return EOK;
+}
+
+static errno_t ethip_set_mac48(iplink_srv_t *srv, eth_addr_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "ethip_set_mac48()");
 
 	ethip_nic_t *nic = (ethip_nic_t *) srv->arg;
-	addr48(*mac, nic->mac_addr);
+	nic->mac_addr = *mac;
 
 	return EOK;
Index: uspace/srv/net/ethip/ethip.h
===================================================================
--- uspace/srv/net/ethip/ethip.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/ethip.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,6 +40,7 @@
 #include <adt/list.h>
 #include <async.h>
+#include <inet/addr.h>
+#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
-#include <inet/addr.h>
 #include <loc.h>
 #include <stddef.h>
@@ -61,5 +62,5 @@
 
 	/** MAC address */
-	addr48_t mac_addr;
+	eth_addr_t mac_addr;
 
 	/**
@@ -73,7 +74,7 @@
 typedef struct {
 	/** Destination Address */
-	addr48_t dest;
+	eth_addr_t dest;
 	/** Source Address */
-	addr48_t src;
+	eth_addr_t src;
 	/** Ethertype or Length */
 	uint16_t etype_len;
@@ -100,9 +101,9 @@
 	arp_opcode_t opcode;
 	/** Sender hardware address */
-	addr48_t sender_hw_addr;
+	eth_addr_t sender_hw_addr;
 	/** Sender protocol address */
 	addr32_t sender_proto_addr;
 	/** Target hardware address */
-	addr48_t target_hw_addr;
+	eth_addr_t target_hw_addr;
 	/** Target protocol address */
 	addr32_t target_proto_addr;
@@ -113,5 +114,5 @@
 	link_t atrans_list;
 	addr32_t ip_addr;
-	addr48_t mac_addr;
+	eth_addr_t mac_addr;
 } ethip_atrans_t;
 
Index: uspace/srv/net/ethip/ethip_nic.c
===================================================================
--- uspace/srv/net/ethip/ethip_nic.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/ethip_nic.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,14 +37,15 @@
 #include <adt/list.h>
 #include <async.h>
-#include <stdbool.h>
 #include <errno.h>
-#include <str_error.h>
 #include <fibril_synch.h>
+#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <io/log.h>
 #include <loc.h>
+#include <mem.h>
 #include <nic_iface.h>
+#include <stdbool.h>
 #include <stdlib.h>
-#include <mem.h>
+#include <str_error.h>
 #include "ethip.h"
 #include "ethip_nic.h"
@@ -193,5 +194,5 @@
 	}
 
-	addr48(nic_address.address, nic->mac_addr);
+	eth_addr_decode(nic_address.address, &nic->mac_addr);
 
 	rc = nic_set_state(nic->sess, NIC_STATE_ACTIVE);
@@ -399,6 +400,6 @@
 		assert(i < count);
 
-		addr48_t mac;
-		addr48_solicited_node(v6, mac);
+		eth_addr_t mac;
+		eth_addr_solicited_node(v6, &mac);
 
 		/* Avoid duplicate addresses in the list */
@@ -407,5 +408,7 @@
 
 		for (size_t j = 0; j < i; j++) {
-			if (addr48_compare(mac_list[j].address, mac)) {
+			eth_addr_t mac_entry;
+			eth_addr_decode(mac_list[j].address, &mac_entry);
+			if (eth_addr_compare(&mac_entry, &mac)) {
 				found = true;
 				break;
@@ -414,8 +417,9 @@
 
 		if (!found) {
-			addr48(mac, mac_list[i].address);
+			eth_addr_encode(&mac, mac_list[i].address);
 			i++;
-		} else
+		} else {
 			count--;
+		}
 	}
 
Index: uspace/srv/net/ethip/pdu.c
===================================================================
--- uspace/srv/net/ethip/pdu.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/pdu.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -60,6 +60,6 @@
 
 	hdr = (eth_header_t *)data;
-	addr48(frame->src, hdr->src);
-	addr48(frame->dest, hdr->dest);
+	eth_addr_encode(&frame->src, hdr->src);
+	eth_addr_encode(&frame->dest, hdr->dest);
 	hdr->etype_len = host2uint16_t_be(frame->etype_len);
 
@@ -93,6 +93,6 @@
 		return ENOMEM;
 
-	addr48(hdr->src, frame->src);
-	addr48(hdr->dest, frame->dest);
+	eth_addr_decode(hdr->src, &frame->src);
+	eth_addr_decode(hdr->dest, &frame->dest);
 	frame->etype_len = uint16_t_be2host(hdr->etype_len);
 
@@ -140,8 +140,8 @@
 	pfmt->proto_addr_size = IPV4_ADDR_SIZE;
 	pfmt->opcode = host2uint16_t_be(fopcode);
-	addr48(packet->sender_hw_addr, pfmt->sender_hw_addr);
+	eth_addr_encode(&packet->sender_hw_addr, pfmt->sender_hw_addr);
 	pfmt->sender_proto_addr =
 	    host2uint32_t_be(packet->sender_proto_addr);
-	addr48(packet->target_hw_addr, pfmt->target_hw_addr);
+	eth_addr_encode(&packet->target_hw_addr, pfmt->target_hw_addr);
 	pfmt->target_proto_addr =
 	    host2uint32_t_be(packet->target_proto_addr);
@@ -203,8 +203,8 @@
 	}
 
-	addr48(pfmt->sender_hw_addr, packet->sender_hw_addr);
+	eth_addr_decode(pfmt->sender_hw_addr, &packet->sender_hw_addr);
 	packet->sender_proto_addr =
 	    uint32_t_be2host(pfmt->sender_proto_addr);
-	addr48(pfmt->target_hw_addr, packet->target_hw_addr);
+	eth_addr_decode(pfmt->target_hw_addr, &packet->target_hw_addr);
 	packet->target_proto_addr =
 	    uint32_t_be2host(pfmt->target_proto_addr);
Index: uspace/srv/net/ethip/pdu.h
===================================================================
--- uspace/srv/net/ethip/pdu.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/srv/net/ethip/pdu.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
